module parallel_reg (
    input wire [7:0] D,  // Параллельный вход данных
    input wire Clock,   //Синхросигнал
    input wire R,      // Асинхронный сброс
	 input wire WE,	  // вход управления записи
    output reg [7:0] Q // Выходные данные
);

    // Процесс, описывающий поведение регистра
    always @(posedge Clock or posedge R) begin
        if (R) begin
            Q <= 8'b0;      // Асинхронный сброс: выход в 0
        end else begin
			if (WE) begin
            Q <= D;         // Запись данных при тактовом фронте
        end
		 end
    end

endmodule