module shift_register (
    input wire C,          // Синхровход
    input wire R,        // Асинхронный сброс (активный высоки уровень)
    input wire DSI,        // Входные данные для сдвига
    input wire DSL,         // Управляющий сигнал сдвига влево
    input wire DSR,         // Управляющий сигнал сдвига вправо
    output reg [3:0] Q      // 4-разрядный выход
);
    always @(posedge C or posedge R) begin
    if (R) 
		begin
        Q <= 4'b0000;  // Сброс регистра 
      end 
      else begin
			if (DSL && !DSR)
			begin
                // Сдвиг влево
                Q <= {Q[2:0], DSI};  // Сдвинуть влево и добавить d_in
         end 
		else if (DSR && !DSL)
			begin
                // Сдвиг вправо
                Q <= {DSI, Q[3:1]};  // Сдвинуть вправо и добавить бит по //линии DSI
         end
            // Если оба сигнала неактивны, значение регистра остается без изменений
      end
    end
endmodule
