`timescale 1ns / 1ps

module testbench;  //     

    reg C;                //  
    reg R;             //  
    reg DSI;              //    
    reg DSL;               //    
    reg DSR;               //    
    wire [3:0] Q;          //  

    //   
    shift_register uut (
        .C(C),
        .R(R),
        .DSI(DSI),
        .DSL(DSL),
        .DSR(DSR),
        .Q(Q)
    );

    //   
    initial begin
        C = 0;
        forever #5 C = ~C;  //     10 
    end

    //   
    initial begin
        //  
        R = 1;    //  
        DSI = 0;
        DSL = 0;
        DSR = 0;

        //  
        #10;
        R = 0;

        //   
        $display("  :");
        DSI = 1; DSL = 1; DSR = 0; 
        #10;
        $display(": %b", Q); // : 0001

        DSI = 0; 
        #10; 
        $display(": %b", Q); // : 0010

        DSI = 1; 
        #10; 
        $display(": %b", Q); // : 0101

        //   
        $display("  :");
        DSL = 0; DSR = 1; 
        #10;
        $display(": %b", Q); // : 1010

        DSI = 0; 
        #10; 
        $display(": %b", Q); // : 0100

        DSI = 1; 
        #10; 
        $display(": %b", Q); // : 0010

        //  
        $finish;
    end

endmodule